/*=========================================================================

						 >>> WonderGUI <<<

  This file is part of Tord Jansson's WonderGUI Graphics Toolkit
  and copyright (c) Tord Jansson, Sweden [tord.jansson@gmail.com].

							-----------

  The WonderGUI Graphics Toolkit is free software; you can redistribute
  this file and/or modify it under the terms of the GNU General Public
  License as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

							-----------

  The WonderGUI Graphics Toolkit is also available for use in commercial
  closed-source projects under a separate license. Interested parties
  should contact Tord Jansson [tord.jansson@gmail.com] for details.

=========================================================================*/

#include <wg_valueformatter.h>

namespace wg
{

	const char ValueFormatter::CLASSNAME[] = {"ValueFormatter"};


	//____ isInstanceOf() _________________________________________________________

	bool ValueFormatter::isInstanceOf( const char * pClassName ) const
	{
		if( pClassName==CLASSNAME )
			return true;

		return Object::isInstanceOf(pClassName);
	}

	//____ className() ____________________________________________________________

	const char * ValueFormatter::className( void ) const
	{
		return CLASSNAME;
	}

	//____ cast() _________________________________________________________________

	ValueFormatter_p ValueFormatter::cast( Object * pObject )
	{
		if( pObject && pObject->isInstanceOf(CLASSNAME) )
			return ValueFormatter_p( static_cast<ValueFormatter*>(pObject) );

		return 0;
	}

} // namespace wg
